//usart.c
#include "usart.h"
#include <pic18.h>

void InitUsart1(void) {
	TXSTA1 		= 0x24;
	RCSTA1 		= 0x90;
	BAUDCON1 	= 0x00;
	SPBRG1		= 129;
}

void Usart1WriteChar(unsigned char ch) {
   
	while(!TRMT) 	// TRMT1 is set when TSR is empty
      continue;
	TXREG = ch;		// load the register

}

unsigned char Usart1ReadChar(void) {
	while(!RCIF) 
		continue;                         
    return RCREG; 
}

unsigned char Usart1ReadChar_nonstop(void) {

	if(!RCIF) 	// TRMT1 is set when TSR is empty
      return 0;   

    return RCREG; 
}

void Usart1WriteText(const unsigned char *txt) {
	unsigned char i = 0;
	while(txt[i]!='\0') {
		Usart1WriteChar(txt[i]);
		i++;
	}

}
